<?php
defined('BASEPATH') or exit('No direct script access allowed');

class ControllerArisan extends CI_Controller
{

    public function __construct()
    {
        parent::__construct();
        check_not_login();
        $this->set_timezone();
        if ($this->session->userdata('level') != 5) {
            redirect();
        }
        $this->load->library('encrypt');
        $this->load->library('form_validation');
        $this->load->library('Mycustom');
        $this->load->library('pdfgenerator');
        $this->load->library('Notifikasi');
        $this->load->model('bagian_kasir/insert_model');
        $this->load->model('bagian_kasir/select_model');
        $this->load->model('bagian_kasir/update_model');
    }
    public function set_timezone()
    {
        date_default_timezone_set("Asia/Jakarta");
    }

    public function index()
    {
        // Notifikasi
        $notif                 = $this->notifikasi->notif_kasir();
        // End_notifikasi 
        // Data Login
        $data_login            = $this->userlogin->user_login();
        $data_id_login         = $this->session->userdata('isloggedin');
        // Query SQL Data atau isi data page 
        $data_arisan_aktif     = $this->select_model->getDataAllArisanAktif(); // Data Semua anggota terdaftar arisan aktif
        // Bagian Arisan Heboh
        // echo '<pre>';
        // var_dump($data_arisan_aktif);
        // die;
        $anggota_aktif         = $this->select_model->getDataAnggotaAktif(); // Data Semua Anggota Arisan Status Aktif
        $anggota_menang        = $this->select_model->getDataAnggotaMenang(); // Data Semua Anggota Arisan Menang
        $anggota_mundur        = $this->select_model->getDataAnggotaMundur(); // Data Semua Anggota Arisan Mundur 
        $data = array(
            // Untuk memanggil halaman sesuai menu
            'folder'              => 'arisan/all',
            'page'                => 'index',
            'judul'               => 'Semua Data Arisan || Bagian Kasir',
            'data_id_login'       => $data_id_login,
            'data_login'          => $data_login,
            'notif'               => $notif,
            // Isi data konten
            'arisan_aktif'        => $data_arisan_aktif,
            // Jumlah anggota arisan
            'anggota_aktif'       => $anggota_aktif,
            'anggota_menang'      => $anggota_menang,
            'anggota_mundur'      => $anggota_mundur
        );
        $this->load->view('kasir/index', $data);
    }
    // Data Menu tagihan
    // Arisan Motor
    public function tagihan_motor($id)
    {
        // Notifikasi
        $notif                 = $this->notifikasi->notif_kasir();
        $kode_arisan           = $this->encrypt->decode($id);
        // Data Arisan
        $data_arisan           = $this->db->get_where('p_arisan', ['id' => $kode_arisan])->row_array();
        $data_jadwal_aktif     = $this->db->get_where('p_arisan_jadwal', ['regist_arisan' => $kode_arisan, 'status_undian !=' => 'SELESAI'])->row_array();
        $jadwal_id             = $data_jadwal_aktif['id'];
        // End_notifikasi 
        // Data Login
        $data_login            = $this->userlogin->user_login();
        $data_id_login         = $this->session->userdata('isloggedin');
        // Query SQL Data atau isi data page 
        // Bagian Atas cek data
        $anggota_aktif            = $this->select_model->getDataAnggotaArisanMotorAktifTerus($kode_arisan); // Menampilkan data anggota aktif
        $jml_aktif                = count($anggota_aktif);  // Menampilkan total anggota aktif
        $data_anggota_belum_bayar = $this->select_model->getDataAnggotaTagihanMotor($jadwal_id, $kode_arisan);  // Menampilkan anggota arisan heboh yang belum bayar
        $ttl_belum_bayar          = count($data_anggota_belum_bayar); // Menampilkan total anggota yang belum bayar
        $data_anggota_bayar       = $this->select_model->getDataAnggotaTagihanMotorSelesai($jadwal_id, $kode_arisan); // Menampilkan anggota arisan heboh yang sudah bayar
        // Bagian Arisan Heboh
        // echo '<pre>';
        // var_dump($kode_arisan);
        // die;
        $anggota_aktif         = $this->select_model->getDataAnggotaAktif(); // Data Semua Anggota Arisan Status Aktif
        $anggota_menang        = $this->select_model->getDataAnggotaMenang(); // Data Semua Anggota Arisan Menang
        $anggota_mundur        = $this->select_model->getDataAnggotaMundur(); // Data Semua Anggota Arisan Mundur 
        $data = array(
            // Untuk memanggil halaman sesuai menu
            'folder'              => 'arisan/all/motor',
            'page'                => 'tagihan_motor',
            'judul'               => 'Iuran Bulanan Arisan Motor || Bagian Kasir',
            'data_id_login'       => $data_id_login,
            'data_login'          => $data_login,
            'notif'               => $notif,
            // Isi data konten
            'jml_aktif'           => $jml_aktif,
            'blm_bayar'           => $ttl_belum_bayar,
            'data_arisan'         => $data_arisan,
            'jadwal_arisan'       => $data_jadwal_aktif,
            'anggota_belum_bayar' => $data_anggota_belum_bayar,
            'anggota_bayar'       => $data_anggota_bayar,
            // Jumlah anggota arisan
            'anggota_aktif'       => $anggota_aktif,
            'anggota_menang'      => $anggota_menang,
            'anggota_mundur'      => $anggota_mundur
        );
        $this->load->view('kasir/index', $data);
    }
    // Arisan Heboh
    public function tagihan_heboh($id)
    {
        // Notifikasi
        $notif                 = $this->notifikasi->notif_kasir();
        $kode_arisan           = $this->encrypt->decode($id);
        // Data Arisan
        $data_arisan           = $this->db->get_where('p_arisan', ['id' => $kode_arisan])->row_array();
        $data_jadwal_aktif     = $this->db->get_where('p_arisan_jadwal', ['regist_arisan' => $kode_arisan, 'status_undian !=' => 'SELESAI'])->row_array();
        $jadwal_id             = $data_jadwal_aktif['id'];
        // End_notifikasi 
        // Data Login 
        $data_login            = $this->userlogin->user_login();
        $data_id_login         = $this->session->userdata('isloggedin');
        // Query SQL Data atau isi data page  
        // Bagian Atas cek data
        $anggota_aktif            = $this->select_model->getDataAnggotaArisanHebohAktif($kode_arisan); // Menampilkan data anggota aktif
        $jml_aktif                = count($anggota_aktif);  // Menampilkan total anggota aktif
        $data_anggota_belum_bayar = $this->select_model->getDataAnggotaTagihan($jadwal_id, $kode_arisan);  // Menampilkan anggota arisan heboh yang belum bayar
        $ttl_belum_bayar          = count($data_anggota_belum_bayar); // Menampilkan total anggota yang belum bayar
        $data_anggota_bayar       = $this->select_model->getDataAnggotaTagihanSelesai($jadwal_id, $kode_arisan); // Menampilkan anggota arisan heboh yang sudah bayar
        // Bagian Arisan Heboh
        // echo '<pre>';
        // var_dump($kode_arisan);
        // die;
        $anggota_aktif         = $this->select_model->getDataAnggotaAktif(); // Data Semua Anggota Arisan Status Aktif
        $anggota_menang        = $this->select_model->getDataAnggotaMenang(); // Data Semua Anggota Arisan Menang
        $anggota_mundur        = $this->select_model->getDataAnggotaMundur(); // Data Semua Anggota Arisan Mundur 
        $data = array(
            // Untuk memanggil halaman sesuai menu
            'folder'              => 'arisan/all/heboh',
            'page'                => 'tagihan',
            'judul'               => 'Iuran Bulanan Arisan Heboh || Bagian Kasir',
            'data_id_login'       => $data_id_login,
            'data_login'          => $data_login,
            'notif'               => $notif,
            // Isi data konten
            'jml_aktif'           => $jml_aktif,
            'blm_bayar'           => $ttl_belum_bayar,
            'data_arisan'         => $data_arisan,
            'jadwal_arisan'       => $data_jadwal_aktif,
            'anggota_belum_bayar' => $data_anggota_belum_bayar,
            'anggota_bayar'       => $data_anggota_bayar,
            // Jumlah anggota arisan
            'anggota_aktif'       => $anggota_aktif,
            'anggota_menang'      => $anggota_menang,
            'anggota_mundur'      => $anggota_mundur
        );
        $this->load->view('kasir/index', $data);
    }
    // Data Pembayaran Iuran
    // Motor
    public function iuran_motor($id)
    {
        $regist_undian                       = $this->encrypt->decode($id);
        $regist_arisan                       = substr($regist_undian, 0, 7);
        $produk_id                           = substr($regist_arisan, 2, 2);
        $data_arisan                         = $this->db->get_where('p_arisan', ['id' => $regist_arisan])->row_array();
        $data_jadwal                         = $this->db->get_where('p_arisan_jadwal', ['regist_arisan' => $regist_arisan, 'status_undian' => 'BELUM'])->row_array();
        $jadwal_id                           = $data_jadwal['id'];
        $cek_anggota                         = $this->db->get_where('p_arisan_anggota', ['regist_undian' => $regist_undian])->row_array();
        // Menampilkan data terakhir invoice
        $data_invoice           = $this->select_model->getDataTagihanUrutMotor();
        $cek_nomor_urut         = substr($data_invoice['id'], 8, 5);
        $no_invoice_selanjutnya = $cek_nomor_urut + 1;
        $total_huruf            = strlen($no_invoice_selanjutnya);
        // Membuat kode invoice
        if ($total_huruf == 1) :
            $nomor_invoice = date('ymd') . '22000' . $no_invoice_selanjutnya;
        elseif ($total_huruf == 2) :
            $nomor_invoice = date('ymd') . '2200' . $no_invoice_selanjutnya;
        elseif ($total_huruf == 3) :
            $nomor_invoice = date('ymd') . '220' . $no_invoice_selanjutnya;
        else :
            $nomor_invoice = date('ymd') . '22' . $no_invoice_selanjutnya;
        endif;
        // Data untuk tabel invoice
        $data_voice = array(
            'id'              => $nomor_invoice,
            'produk_id'       => 22,
            'anggota_id'      => $cek_anggota['anggota_id'],
            'tgl_pembayaran'  => date('Y-m-d'),
            'qty_pembayaran'  => 1,
            'ttl_bayar'       => $data_arisan['tagihan_iuran'] * 1,
            'status_kas'      => 'MASUK',
            'status_nota'     => 'TERIMA',
            'ket_nota'        => 'Iuran Arisan ' . $regist_arisan . ' Nomor Undian ' . $regist_undian,
            'petugas'         => $this->session->userdata('isloggedin'),
            'kasir'         => $this->session->userdata('isloggedin')
        );
        $this->db->insert('nota', $data_voice);
        $data_rinci = array(
            'nota_id'       => $nomor_invoice,
            'jadwal_id'     => $jadwal_id,
            'regist_arisan' => $regist_arisan,
            'regist_undian' => $regist_undian,
            'bayar'         => $data_arisan['tagihan_iuran'],
            'status_bayar'  => 'LANCAR',
        );
        $this->db->insert('p_arisan_nota', $data_rinci);
        $this->_cetakTandaTerima($nomor_invoice, $produk_id);
        $this->session->set_flashdata('pesan_berhasil', '<div class="alert alert-success" id="pesan_berhasil" role="alert">Berhasil Bayar Tagihan Arisan!</div>');
        redirect('kasir/arisan/detail_motor/' . $this->encrypt->encode($regist_arisan));
    }
    // Heboh
    public function iuran_heboh($id)
    {
        $regist_undian                       = $this->encrypt->decode($id);
        $regist_arisan                       = substr($regist_undian, 0, 7);
        $produk_id                           = substr($regist_arisan, 2, 2);
        $data_arisan                         = $this->db->get_where('p_arisan', ['id' => $regist_arisan])->row_array();
        $data_jadwal                         = $this->db->get_where('p_arisan_jadwal', ['regist_arisan' => $regist_arisan, 'status_undian' => 'BELUM'])->row_array();
        $jadwal_id                           = $data_jadwal['id'];
        $cek_anggota                         = $this->db->get_where('p_arisan_anggota', ['regist_undian' => $regist_undian])->row_array();
        // Menampilkan data terakhir invoice
        $data_invoice                        = $this->select_model->getDataTagihanUrutHeboh();
        $cek_nomor_urut                      = substr($data_invoice['id'], 8, 5);
        $no_invoice_selanjutnya              = $cek_nomor_urut + 1;
        $total_huruf                         = strlen($no_invoice_selanjutnya);
        // Membuat kode invoice
        if ($total_huruf == 1) :
            $nomor_invoice = date('ymd') . '21000' . $no_invoice_selanjutnya;
        elseif ($total_huruf == 2) :
            $nomor_invoice = date('ymd') . '2100' . $no_invoice_selanjutnya;
        elseif ($total_huruf == 3) :
            $nomor_invoice = date('ymd') . '210' . $no_invoice_selanjutnya;
        else :
            $nomor_invoice = date('ymd') . '21' . $no_invoice_selanjutnya;
        endif;
        // Data untuk tabel invoice
        $data_voice = array(
            'id'              => $nomor_invoice,
            'produk_id'       => 21,
            'anggota_id'      => $cek_anggota['anggota_id'],
            'tgl_pembayaran'  => date('Y-m-d'),
            'qty_pembayaran'  => 1,
            'ttl_bayar'       => $data_arisan['tagihan_iuran'] * 1,
            'status_kas'      => 'MASUK',
            'status_nota'     => 'TERIMA',
            'ket_nota'        => 'Iuran Arisan ' . $regist_arisan . ' Nomor Undian ' . $regist_undian,
            'petugas'         => $this->session->userdata('isloggedin'),
            'kasir'           => $this->session->userdata('isloggedin')
        );
        $this->db->insert('nota', $data_voice);
        $data_rinci = array(
            'nota_id'       => $nomor_invoice,
            'jadwal_id'     => $jadwal_id,
            'regist_arisan' => $regist_arisan,
            'regist_undian' => $regist_undian,
            'bayar'         => $data_arisan['tagihan_iuran'],
            'status_bayar'  => 'LANCAR',
        );
        $this->db->insert('p_arisan_nota', $data_rinci);
        $this->_cetakTandaTerima($nomor_invoice, $produk_id);
        $this->session->set_flashdata('pesan_berhasil', '<div class="alert alert-success" id="pesan_berhasil" role="alert">Berhasil Bayar Tagihan Arisan!</div>');
        redirect('kasir/arisan/detail_heboh/' . $this->encrypt->encode($regist_arisan));
    }
    // Private Function
    // Konversi Nota Tanda Terima
    private function _cetakTandaTerima($nomor_invoice, $produk_id)
    {
        $kd_invoice            = $nomor_invoice;
        $data_invoice          = $this->select_model->getDataInvoice($kd_invoice); // DONE
        $data_rinci            = $this->select_model->getDataInvoiceRinci($kd_invoice);
        // Data Login
        $data_login            = $this->userlogin->user_login();
        $data_id_login         = $this->session->userdata('isloggedin');
        // Nama Marketing
        $data_marketing        = $this->select_model->getDataMarketing($kd_invoice);
        $data_kasir            = $this->select_model->getDataKasir($kd_invoice);
        $data = array(
            // Untuk memanggil halaman sesuai menu
            'title_pdf'           => 'Invoice Pembayaran Arisan',
            'data_id_login'       => $data_id_login,
            'data_login'          => $data_login,
            // Data isi konten
            'data_invoice'        => $data_invoice,
            'data_rinci'          => $data_rinci,
            'data_marketing'      => $data_marketing,
            'data_kasir'          => $data_kasir
        );
        // $this->load->view('nota/nota_bayar_arisan', $data_halaman);
        // filename dari pdf ketika didownload
        $file_pdf = 'invoice_' . $kd_invoice;
        // setting paper
        $paper = 'A5';
        //orientasi paper potrait / landscape
        $orientation = "landscape";

        // $this->load->view('nota/nota_bayar_arisan_petugas', $data);
        $html = $this->load->view('document/nota/nota_bayar_arisan_kasir', $data, true);
        $tahun = date('Y');
        $bulan = date('m');
        // run dompdf
        if ($produk_id == 21) :
            $lokasi_file = 'assets/invoice/arisan_heboh/' . $tahun . '/' . $bulan . '/';
        else :
            $lokasi_file = 'assets/invoice/arisan_motor/' . $tahun . '/' . $bulan . '/';
        endif;
        $this->pdfgenerator->generate($html, $file_pdf, $paper, $lokasi_file, $orientation);
        $data_update22     = array(
            'invoice_pdf' => $file_pdf . '.pdf'
        );
        $this->db->where('id', $kd_invoice);
        $this->db->update('nota', $data_update22);
        $nama_file = $file_pdf . '.pdf';
        $cek_option = $this->db->get_where('sistem_option')->row_array();
        $this->_notifWABuktiSetorAsli($nama_file, $lokasi_file, $data_invoice, $cek_option);
    }
    // Notifikasi WA Bukti Setor Nomor Saya
    private function _notifWABuktiSetorAsli($nama_file, $lokasi_file, $data_invoice, $cek_option)
    {
        $cek_nomor = substr($data_invoice['no_hp'], 0, 1);
        if ($cek_nomor == 0) :
            $no_hp = '62' . substr($data_invoice['no_hp'], 1, 20);
        else :
            $no_hp = $data_invoice['no_hp'];
        endif;

        if ($data_invoice['produk_id'] == 21) :
            $produk = 'Arisan Heboh';
        elseif ($data_invoice['produk_id'] == 22) :
            $produk = 'Arisan Motor';
        endif;

        $pesan = 'Hei, *_' . $data_invoice['nm_anggota'] . '_*,

Terimakasih sudah melakukan pembayaran iuran ' . $produk . ', Klik link dibawah untuk melihat invoice pembayaran Anda.

Link Invoice : https://siap.kspbinaartha.com/' . $lokasi_file .  $nama_file . '

*Info :* ' . $cek_option['cs_arisan'] . '
*_PESAN OTOMATIS ROBIN_*';

        $sett_wa = $this->db->get_where('sistem_wa', ['id' => 1])->row_array();
        $footer = '*KSP Bina Artha Prima*';
        $data_inputan = array(
            'api_key'    => $sett_wa['api_key'],
            'sender'     => $sett_wa['no_hp'],
            'number'     => $no_hp,
            'message'    => $pesan,
            'footer'     => $footer
        );
        $curl = curl_init($sett_wa['endpoint_url']);
        curl_setopt($curl, CURLOPT_POST, true);
        curl_setopt($curl, CURLOPT_POSTFIELDS, http_build_query($data_inputan));
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
        curl_exec($curl);
        curl_close($curl);
    }
}

/* End of file ControllerArisan.php and path \application\controllers\kasir\arisan\ControllerArisan.php */